﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TohleBudeUkol
{
    public enum Direction { up, down, left, right }

    public class BoardCoords
    {
        static BoardCoords invalid = new BoardCoords(-1, -1);

        public int Row { get; set; }
        public int Col { get; set; }
        public BoardCoords(int row, int col)
        {
            Row = row;
            Col = col;
        }

        public BoardCoords Up(int offset)
        {
            return new BoardCoords(Row - offset, Col);
        }
        public BoardCoords Down(int offset)
        {
            return new BoardCoords(Row + offset, Col);
        }
        public BoardCoords Left(int offset)
        {
            return new BoardCoords(Row, Col + offset);
        }
        public BoardCoords Right(int offset)
        {
            return new BoardCoords(Row, Col - offset);
        }
        public BoardCoords Shift(Direction direction, int offset)
        {
            switch (direction)
            {
                case Direction.up:
                    return Up(offset);
                case Direction.down:
                    return Down(offset);
                case Direction.left:
                    return Left(offset);
                case Direction.right:
                    return Right(offset);
                default:
                    return new BoardCoords(-1, -1);
            }
        }
        public BoardCoords Shift(Direction direction)
        {
            return Shift(direction, 1);
        }
    }
}
